
import java.io.BufferedReader;
import java.io.File;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Scanner;
import org.apache.log4j.Appender;
import org.apache.log4j.Logger;
import org.apache.log4j.lf5.Log4JLogRecord;
import org.apache.log4j.net.SocketAppender;

/**
 * TODO: documentation pending.
 *
 * @author Vítor E. Silva Souza (vitorsouza@gmail.com)
 */
public class EeatCbeTest {
	private static final Logger logger = Logger.getLogger("org.eeat.log4j.appenders.CbeToOclMessageAppender");

	static {
		SocketAppender socketAppender = new SocketAppender("localhost", 4560);
		socketAppender.setLocationInfo(true);
		logger.addAppender(socketAppender);
	}

	private static final DateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS'Z'");

	private static String cbeTemplate;

	public static void main(String[] args) throws Exception {
		// Reads the template for a CBE event from a file.
		File templateFile = new File("cbetemplate.txt");
		StringBuilder builder = new StringBuilder();
		Scanner scanner = new Scanner(templateFile);
		while (scanner.hasNextLine()) builder.append(scanner.nextLine()).append('\n');
		cbeTemplate = builder.toString();

		// Creates an event in the CBE format.
		String event = createCbeEvent("it.unitn.disi.awreqs.impl.ads.TInputInfoImpl", "success");

		// Sends the event to EEAT.
		logger.info(event);
	}

	private static String createCbeEvent(String clazz, String method) {
		String time = dateFormat.format(new Date(System.currentTimeMillis()));
		return cbeTemplate.replace("$class", clazz).replace("$method", method).replace("$timestamp", time);
	}
}
